org.apache.poi.sl.usermodel

## Interface ShapeContainer<S extends Shape<S,P>,P extends TextParagraph<S,P,? extends TextRun>>

- All Superinterfaces:
    java.lang.Iterable<S>
  All Known Subinterfaces:
    GroupShape<S,P>, HSLFShapeContainer, MasterSheet<S,P>, Notes<S,P>, Sheet<S,P>, Slide<S,P>, XSLFShapeContainer
  All Known Implementing Classes:
    HSLFGroupShape, HSLFMasterSheet, HSLFNotes, HSLFSheet, HSLFSlide, HSLFSlideMaster, HSLFTable, HSLFTitleMaster, XSLFGroupShape, XSLFNotes, XSLFNotesMaster, XSLFSheet, XSLFSlide, XSLFSlideLayout, XSLFSlideMaster

      public interface ShapeContainer<S extends Shape<S,P>,P extends TextParagraph<S,P,? extends TextRun>>
      extends java.lang.Iterable<S>

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addShape(S shape)`
    `AutoShape<S,P>` | `createAutoShape()` create a new shape with a predefined geometry and add it to this shape container
    `ConnectorShape<S,P>` | `createConnector()` create a connector
    `FreeformShape<S,P>` | `createFreeform()` create a new shape with a custom geometry
    `GroupShape<S,P>` | `createGroup()` create a group of shapes belonging to this container
    `ObjectShape<?,?>` | `createOleShape(PictureData pictureData)` Create a new OLE object shape with the given pictureData as preview image
    `PictureShape<S,P>` | `createPicture(PictureData pictureData)` create a picture belonging to this container
    `TableShape<S,P>` | `createTable(int numRows, int numCols)` Create a new Table of the given number of rows and columns
    `TextBox<S,P>` | `createTextBox()` create a text box
    `java.util.List<S>` | `getShapes()` Returns an list containing all of the elements in this container in proper sequence (from first to last element).
    `boolean` | `removeShape(S shape)` Removes the specified shape from this sheet, if it is present (optional operation).

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, iterator, spliterator`

- - ### Method Detail

    - #### getShapes

          java.util.List<S> getShapes()

      Returns an list containing all of the elements in this container in proper sequence (from first to last element).
      Returns:
        an list containing all of the elements in this container in proper sequence

    - #### addShape

          void addShape(S shape)

    - #### removeShape

          boolean removeShape(S shape)

      Removes the specified shape from this sheet, if it is present (optional operation). If this sheet does not contain the element, it is unchanged.
      Parameters:
        `shape` - the shape to be removed from this sheet, if present
      Returns:
        `true` if this sheet contained the specified element
      Throws:
        `java.lang.IllegalArgumentException` - if the type of the specified shape is incompatible with this sheet (optional)

    - #### createAutoShape

          AutoShape<S,P> createAutoShape()

      create a new shape with a predefined geometry and add it to this shape container

    - #### createFreeform

          FreeformShape<S,P> createFreeform()

      create a new shape with a custom geometry

    - #### createTextBox

          TextBox<S,P> createTextBox()

      create a text box

    - #### createConnector

          ConnectorShape<S,P> createConnector()

      create a connector

    - #### createGroup

          GroupShape<S,P> createGroup()

      create a group of shapes belonging to this container

    - #### createPicture

          PictureShape<S,P> createPicture(PictureData pictureData)

      create a picture belonging to this container

    - #### createTable

          TableShape<S,P> createTable(int numRows,
                                      int numCols)

      Create a new Table of the given number of rows and columns
      Parameters:
        `numRows` - the number of rows
        `numCols` - the number of columns

    - #### createOleShape

          ObjectShape<?,?> createOleShape(PictureData pictureData)

      Create a new OLE object shape with the given pictureData as preview image
      Parameters:
        `pictureData` - the preview image

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.